#ifndef __MODEL__
#define __MODEL__

#import "../sgCore/sgCore.h"

#include <vector>

class   HouseModel
{
public:
	HouseModel() {};

	void   Build(sgFloat log_size, sgFloat houseSizeX, sgFloat houseSizeY);

private:
	sgCContour*    m_log_section;
	sgFloat        m_logs_shifts;

	std::vector<sgC3DObject*>     m_walls[4];

	void           BuildLogSection(sgFloat log_size);
	sgC3DObject*   BuildLog(sgFloat logH, bool withGroove, sgFloat groove_size,sgFloat grooveShift);

	void           BuildWall(int wallIndex, sgFloat log_size, sgFloat houseSizeX, sgFloat houseSizeY);
	void           BuildWindow(sgFloat houseSizeX,sgFloat houseSizeY);

	void           CutForRoof(sgFloat log_size, sgFloat houseSizeX,sgFloat houseSizeY);
	void           BuildRoof(sgFloat log_size, sgFloat houseSizeX,sgFloat houseSizeY);
};

void BuildModel();

#endif